/*
 *			LisezMoi with my Windows Manager 
 *                 
 *
 * Author	: METALLICA
 * Date		: 13 Decembre 1993
 * Revision	: 24 Novembre 1994
 * Version	: 1.02
 * Release	: 1.85
 * Language	: Pure C, Version du 3 Fevrier 1992 
 *
 * 
 * Commentaire: "Parle" le Francais, l'Allemand et l'Anglais
 *
 * Bug corrige sur l'appel au selecteur de fichiers etendu des TOS 1.4
 *
 *		- ATARI ST, STE, MEGA ST/STE, TT & Falcon -
 *			( STBook et STacy aussi !)
 */

#include <stdio.h>
#include <tos.h>
#include <string.h>

#include "F:\Aads.030\include\PCAADS.h"

#define FRANCAIS	0		/* Langues supportees */
#define DEUTSCH		1
#define ENGLISH		2

#define FILE_ERROR	0		/* erreur retournee par */
#define RAM_ERROR      -1		/* Lire_Fichier 	*/
#define OK		1

int	langage;			/* indicateur de langue	 */
char    **texte;			/* liste des lignes du texte */
long    nb_ligne=0L;			/* nombre de lignes totales  */
long	ligne_depart=0L;		/* ligne de depart ou afficher */
int	nb_colonne=0;			/* nombre de colonnes max. */
int	colonne_depart=0;		/* colonne de depart ou afficher */
int	quitter=0;			/* Pour quitter le programme */

char	filename[255]="\0";
char	name[16]     ="\0";
char 	suffix[16]   ="*.DOC\0";	/* ! L'extension par defaut ! */
char	prefix[255]  ="\0";		/* Disque et chemin par defaut */
char    wintitre[100]="\0";
char    wininfo[100] ="\0";

/*
 * ------------------  Listes des messages en trois langues --------------
 */
				
char    titre[3][50]={	   "LisezMoi Window Version 1.02\0",
		  	   "LiesMich Window Version 1.02\0",
		  	   "ReadMe Window Version 1.02\0"};
					   
char	info[3][50]={	   "Fichier: %s  Total lignes: %ld\0",
		 	   "Datei: %s  Gesamt Zeile: %ld\0",
		 	   "File: %s  Total lines: %ld\0"}; 
					 
char    win_erreur[3][50]={"[1][| Plus de fenetre disponible ][Ok]",
			   "[1][| keine freie fenster mehr ][Ok]",
			   "[1][| Not enough free window ][Ok]"};

char	txtquit[3][50]={   "[2][| Quitter LisezMoi ][ Oui | Non ]",
			   "[2][| Ende LiesMich ][ Ja | Abbruch ]",
			   "[2][| Quit ReadMe ][ Yes | Cancel ]"};

char	label_selector[3][30]={	"LECTURE D'UN FICHIER\0",
				"LIESMICH DATEI LESEN\0",
				"README SELECT FILE\0"};
							   
/*
 * --------------------- Primitives de notre Application  ------------------
 */

void Liberer_Memoire(void)
/*
  Libere le couple de Mallocs effectues pour charger le fichier.
*/
{
  Mfree(texte[0L]);
  Mfree(texte);
}

int Lecture_Fichier(char *filename)
/*
  Effectue le chargement complet du fichier en indiquant si reussi 
  ou non
*/
{
  FILE	*fichier;
  char	octet;    
  DTA	*ptrdta;
  long	indice;
  long	ligne;
  char	*tampon;
  int	compte_colonne;			/* Compte les colonnes/lignes */
  
  fichier = fopen(filename,"r");
  if( fichier == NULL || Fsfirst(filename,0) )
    return(FILE_ERROR);   

  ptrdta = Fgetdta();
  if( (tampon = Malloc( ptrdta->d_length)) == NULL )
  {
    fclose(fichier);			/* Quitte car plus de RAM */
    return(RAM_ERROR);
  }

  indice     = 0L;
  nb_ligne   = 0L;
  compte_colonne = 0;
  nb_colonne = 0;
  octet = getc(fichier);
  while( !feof(fichier) )
  {
    if(octet == 10 || octet == 13 )	/* Detecte fin de ligne */
    {
      tampon[indice++] = '\0';
      nb_ligne++;
      if(compte_colonne > nb_colonne)	/* Une ligne plus grandre */
        nb_colonne = compte_colonne;
      compte_colonne = 0;
    }
    else 
    {
      if(octet != '\t')			/* +1 pour 1 caractere */
        compte_colonne++;
      else				/* +'tabulation pour \t */
        compte_colonne+=tabulation;
      tampon[indice++] = octet; 
    }/*endif*/
    octet = getc(fichier);
  }/*endwhile*/
  /*
  	La derniere ligne peut ne pas avoir de CR a la fin !
  	Alors on en ajoute UN si necessaire.
  */
  if(tampon[indice-1] != 10 || tampon[indice-1] != 13)
  {
    tampon[indice++] = '\0';
    nb_ligne ++;
  }
  if(compte_colonne > nb_colonne)	/* pour la derniere ligne */
    nb_colonne = compte_colonne;
    
  fclose(fichier);			/* Fermer le fichier */

  /*
    Allouer la table d'acces aux lignes et calculer les adresses de ces
    lignes.
  */
  if( (texte=Malloc( nb_ligne * sizeof(char *))) == NULL)
    return(RAM_ERROR);

  texte[0L] = tampon;
  ligne     = 1L;
  while( ligne < nb_ligne)
  {
    if(*tampon++ == '\0')
    {
      texte[ligne] = tampon;
      ligne++;
    }
  }
  return(OK);
}/*endfunc*/

/*
 * ---------------------- Procdures associes aux fenetres ---------------------
 */


/*
	Gestion des organes de la fenetre verticaux
*/
 
void SetVSlider(int handle)
/*
  Procedure calculant la taille et la position du slider vertical:
  - Appelee par le gestionnaire lors d'un full window.
  - Par le procedures U/Down page/line.
*/
{
  if( (long)W_GMaxLine(handle) >= nb_ligne )	/* Petit document */
    wind_set(handle,WF_VSLIDE,0,0,0,0);		/* inferieur fenetre */
  else						/* Doc. sup. fenetre */
    wind_set(handle,WF_VSLIDE,			
             (int)((long)1000 * ((long)ligne_depart) / 
             	  ((long)nb_ligne-(long)W_GMaxLine(handle))),0,0,0);
             
  wind_set(handle,WF_VSLSIZE,			/* set taille */
           (int)((long)1000 * (long)W_GMaxLine(handle) / (long)nb_ligne),
           0,0,0);
}

void WUpline(int handle)
/*
	Fleche de Scrolling Vers le Haut
*/
{
  int 	table[8];
  int	x,y,w,h;
  long  dummy=0L;
  int	hauteur_cell;
  int	max_line;
  int	handle_actif;
  
  hauteur_cell = A_GCellHeigh();
  max_line     = W_GMaxLine(handle);
  wind_get(handle,WF_TOP,&handle_actif,0,0,0);
  if(ligne_depart > 0L && handle == handle_actif)
  {
    ligne_depart--;
    wind_get(handle,WF_WORKXYWH,&x,&y,&w,&h);  
    table[0]=x;				/* Zone Source */
    table[1]=y;
    table[2]=x+w-1;
    table[3]=y+(max_line-1) * hauteur_cell;
    table[4]=x;				/* Destination */
    table[5]=y+hauteur_cell;
    table[6]=x+w-1;
    table[7]=y+max_line * hauteur_cell;
    vro_cpyfm(VdiHandle,3,table,(MFDB *)&dummy,(MFDB *)&dummy);

    table[0] = x;			/* Effacer premiere ligne */
    table[1] = y;
    table[2] = x+w-1;
    table[3] = y+hauteur_cell;
    vsf_interior(VdiHandle,0);
    vsf_perimeter(VdiHandle,0);
    v_bar(VdiHandle,table);
    vsf_perimeter(VdiHandle,1);
    W_HomeCursor(handle);			/* Cursueur en derniere ligne */
    table[0] = x;			/* Clipping et ecrire nouvelle ligne */
    table[1] = y;
    table[2] = x+w-1;
    table[3] = y+hauteur_cell;
    W_OnClip(table); 
    W_Printf(handle,texte[ligne_depart]);
    W_OffClip(table); 
    SetVSlider(handle);
  }
}

void WDnline(int handle)
/*
	Fleche de Scrolling Vers le Bas
*/
{
  int 	table[8];
  int	x,y,w,h;
  long  dummy=0L;
  long  ligne;
  int	hauteur_cell;
  int	max_line;
  int	handle_actif;
  
  hauteur_cell = A_GCellHeigh();
  max_line     = W_GMaxLine(handle);
  wind_get(handle,WF_TOP,&handle_actif,0,0,0);
  if(ligne_depart + W_GMaxLine(handle) < nb_ligne && handle == handle_actif)
  {
    wind_set(handle,WF_TOP,0,0,0,0);
    ligne_depart++;
    wind_get(handle,WF_WORKXYWH,&x,&y,&w,&h);  
    table[0]=x;				/* Scroller les lignes */
    table[1]=y+hauteur_cell;
    table[2]=x+w-1;
    table[3]=y+max_line * hauteur_cell;
    table[4]=x;
    table[5]=y;
    table[6]=x+w-1;
    table[7]=y+(max_line-1) * hauteur_cell;
    vro_cpyfm(VdiHandle,3,table,(MFDB *)&dummy,(MFDB *)&dummy);

    table[0] = x;			/* Effacer derniere ligne */
    table[1] = y +(max_line-1) * hauteur_cell+1;
    table[2] = x+w-1;
    table[3] = y+h-1;
    vsf_interior(VdiHandle,0);
    vsf_perimeter(VdiHandle,0);
    v_bar(VdiHandle,table);
    vsf_perimeter(VdiHandle,1);

    ligne = ligne_depart + max_line - 1;

    W_SLine(handle,max_line);
    table[0] = x;			/* Clipping et ecrire nouvelle ligne */
    table[1] = y;
    table[2] = x+w-1;
    table[3] = y+h-1;
    W_OnClip(table);     
    W_Printf(handle,texte[ligne]);
    W_OffClip(table); 
    SetVSlider(handle);
  }
}

void WUppage(int handle)
/*
  Scrolling Haut d'une page fenetre
*/
{
  if(ligne_depart-(long)W_GMaxLine(handle) > 0L)
  {
    ligne_depart-=(long)W_GMaxLine(handle);
    W_Redraw(handle);
    SetVSlider(handle);
  }
  else if( ligne_depart > 0L)
  {
    ligne_depart = 0L;
    W_Redraw(handle);
    SetVSlider(handle);
  }
  
}

void WDnpage(int handle)
/*
  Scrolling Bas d'une page fenetre
*/
{
  if(ligne_depart+2L*(long)W_GMaxLine(handle) < nb_ligne)
  {
    ligne_depart+=(long)W_GMaxLine(handle);
    W_Redraw(handle);
    SetVSlider(handle);
  }
  else
  {
    ligne_depart=nb_ligne-(long)W_GMaxLine(handle);
    W_Redraw(handle);
    SetVSlider(handle);
  }
}

void WVSlide(int handle,int position)
/*
	Gestion du mouvement du slider vertical
*/
{
  ligne_depart =(long)position * 
  		(long)( nb_ligne-W_GMaxLine(handle) ) / 1000L;
  W_Redraw(handle);
}

/*
	Gestion des organes de la fenetre horizontaux
*/

void SetHSlider(int handle)
/*
  Procedure calculant la taille et la position du slider horizontal:
  - Appelee par le gestionnaire lors d'un full window.
  - Par le procedures U/Down page/line.
*/
{
  if( W_GMaxColum(handle) >= nb_colonne )	/* Petit document */
    wind_set(handle,WF_HSLIDE,			/* inferieur fenetre */
    		 0,0,0,0);
  else						/* Doc. sup. fenetre */
    wind_set(handle,WF_HSLIDE,			
             (int)((long)1000 * ((long)colonne_depart) / 
             	  ((long)nb_colonne-(long)W_GMaxColum(handle))),
             0,0,0);
             
  wind_set(handle,WF_HSLSIZE,			/* set taille */
           (int)((long)1000 * (long)W_GMaxColum(handle) / (long)nb_colonne),
           0,0,0);
}

void WLTColum(int handle)
/*
	Gestion de la fleche gauche 
*/
{
  if(colonne_depart > 0)
  {
    colonne_depart--;
    SetHSlider(handle);
    W_Redraw(handle);
  }
}

void WRTColum(int handle)
/*
	Gestion de la fleche droite
*/
{
  if(colonne_depart+W_GMaxColum(handle)<nb_colonne)
  {
    colonne_depart++;
    SetHSlider(handle);
    W_Redraw(handle);
  }
}

void WLTPage(int handle)
/*
	Gestion clic page gauche
*/
{
  if(colonne_depart-W_GMaxColum(handle) > 0)
  {
    colonne_depart -=W_GMaxColum(handle);
    SetHSlider(handle);
    W_Redraw(handle);
  }
  else if( colonne_depart > 0)
  {
    colonne_depart = 0;
    SetHSlider(handle);
    W_Redraw(handle);
  }
}

void WRTPage(int handle)
/*
	Gestion clic page droite
*/
{
  if(colonne_depart+2*W_GMaxColum(handle) < nb_colonne)
  {
    colonne_depart +=W_GMaxColum(handle);
    SetHSlider(handle);
    W_Redraw(handle);
  }
  else
  {
    colonne_depart = nb_colonne-W_GMaxColum(handle);
    SetHSlider(handle);
    W_Redraw(handle);
  }
}

void WHSlide(int handle,int position)
/*
	Gestion du mouvement du slider horizontal
*/
{
  colonne_depart =(int)(position * (long)(nb_colonne-W_GMaxColum(handle))/1000L);
  W_Redraw(handle);
}

void SetVHSlider(int handle)
/*
	Recalcul les sliders H et V lors d'un Sized ou Full Window
	(taille et position)
*/
{
  SetVSlider(handle);
  SetHSlider(handle);
}


void WAffiche(int handle)
/*
	Affiche le nombre exacte de lignes possibles dans la fenetre
	'handle' du document texte courant.
	Entree:	'texte[]' = liste des lignes du texte
		'ligne_max'
		'ligne_depart'
		'colonne_depart'
*/
{
  long ligne,ligne_max;

  W_HomeCursor(handle);
  ligne     = ligne_depart;
  ligne_max = ligne_depart + W_GMaxLine(handle);
  W_SColum(handle,-1 * colonne_depart);
  while( ligne < nb_ligne && ligne < ligne_max )
    W_Printf(handle,texte[ligne++]);
}

void WFermer(int handle)
/*
	Procedure appelee par le gestionnaire de fenetre lors
	d'un evenement de fermeture sur celle-ci.
	Entree: 'handle' = handle GEM de la fenetre
*/
{
  int	erreur;
  
  if( A_FileSelector(filename,name,suffix,prefix,label_selector[langage]) )  
  {
    Liberer_Memoire();
    if((erreur=Lecture_Fichier(filename))==OK)
    {
      ligne_depart   = 0L;
      colonne_depart = 0;
      W_Redraw(handle);		/* s'envoyer un Redraw */
      SetVHSlider(handle);
      sprintf(wininfo,info[langage],name,nb_ligne);
      wind_set(handle,WF_INFO,wininfo,0,0);
    }
    else
    {
      switch(erreur)
      {
        case FILE_ERROR:form_error(2);
	       		break;
        case RAM_ERROR: form_error(8);
        		break;
        default:	form_error(1);
        		break;
      }
    }
  }
  else
  {
    if( form_alert(1,txtquit[langage]) == 1 )
    {
      quitter = 1;
      W_Close(handle);
    }
  }
}

/*
 * ---------------------- Corps du programme principal ---------------------
 */

int main(int argc, char **argv)
{
  Type_Parameter_Window	*parameter;
  int	handle;				/* Handle de la fenetre */
  int	vingtieme;			/* 1/20 de l'ecran = bordure */
  int	erreur;				/* erreur de Lecture_Fichier */        
    
  if(!A_Open(NULL))
  {
    form_alert(1,"[0][ | Critical Application error ][ok]");
    Pterm0();				/* On se dclare  l'AES et la VDI */
  }
  graf_mouse(ARROW,NULL);		/* juste pour le "fun" */
  W_Init();				/* Init. le gestionnaire */
  /* 
  	Determiner la langue active de l'ordinateur
  */
  switch(MchInfo.Language)
  {
    case LG_USA:langage = ENGLISH;		/* USA */
                break;
    case LG_GB:	langage = ENGLISH;		/* GB  */
                break;
    case LG_D:	langage = DEUTSCH;		/* Deutschland */
                break;
    default:  	langage = FRANCAIS;		/* France et autres */
  }   
  /* 
  	Fichier passe en parametre (Grace a "Installer une application")
  */
  if(argc>1)				/* Oui ! */
  {
    strcpy(name,argv[1]);
    strcpy(filename,name);
  }
  else					/* Non -> File Selector */
    A_FileSelector(filename,name,suffix,prefix,
    			  label_selector[langage]);

  if((erreur=Lecture_Fichier(filename)) != 1)
  {
    switch(erreur)
    {
      case FILE_ERROR:form_error(2);
    	  	      break;
      case RAM_ERROR: form_error(8);
        	      break;
      default:        form_error(1);
        	      break;
    }
  }
  else
  {
    sprintf(wininfo,info[langage],name,nb_ligne);
    vingtieme = (VdiInfo.HauteurStation-DesktopMenu-5)/20;
    
    parameter = W_GetParameter();
    strcpy(parameter->titre,titre[langage]);
    strcpy(parameter->info,wininfo);
    parameter->x	= 0;
    parameter->y	= (DesktopMenu+5)+(vingtieme);
    parameter->w	= VdiInfo.LargeurStation;
    parameter->h	= VdiInfo.HauteurStation-DesktopMenu-5-(2*vingtieme);
    parameter->attributs= NAME|CLOSER|FULLER|MOVER|INFO|SIZER|UPARROW|DNARROW|
    			  VSLIDE|LFARROW|RTARROW|HSLIDE|SMALLER;
    parameter->op_close		= WFermer;
    parameter->op_redraw	= WAffiche;
    parameter->op_full		= SetVHSlider;
    parameter->op_sized		= SetVHSlider;
    parameter->op_uppage	= WUppage;
    parameter->op_downpage	= WDnpage;
    parameter->op_upline	= WUpline;
    parameter->op_downline	= WDnline;
    parameter->op_rightpage	= WRTPage;
    parameter->op_leftpage	= WLTPage;
    parameter->op_rightcolum	= WRTColum;
    parameter->op_leftcolum 	= WLTColum;
    parameter->op_vslider	= WVSlide;
    parameter->op_hslider	= WHSlide;

    handle  = W_Open(parameter);
    if( handle<=0 )
      form_alert(1,win_erreur[langage]);
    else
    {
      SetVHSlider(handle);
      do
      {
        A_WaitEvent();
        W_Event();
      }	
      while(!quitter);			/* Tant Que non VAR quitter=VRAI */
    }
  Liberer_Memoire();
  }
  A_Close();				/* On previent l'AES et la VDI */
  return(0);
}
/*
	End of LisezMoi.app
*/
